//+------------------------------------------------------------------+
//|                                                                  |
//|                 Copyright  1999-2006, MetaQuotes Software Corp. |
//|                                         http://www.metaquotes.ru |
//+------------------------------------------------------------------+
 
#include <WinUser32.mqh> //   MB_OK|MB_ICONEXCLAMATION

string Versiya = "Test";

bool New_Bar=false;              //     

extern bool Est_Dist_SL  =true; //   SL (pt),   false  StopLoss  High  Low
extern int Dist_SL       =300;   //   Dist_SL 

extern int Dist_TP       =2000;  //  TP (pt)
extern double Prots      =0.10;  //  . .
extern double Lots       =0.10;  //    

extern double MAp        =14;    // MA 
extern double MAs        =0;     // MA 
extern double MAm        =0;     //  

int TimeCycle =60;     //===      .
int TimeCycle2=5;      //===     ,    .
int countSymbol;       //===    ( Symbol_array[])
int countPeriod;       //===    ( Period_array[])

string Symbol_array[]={
//"AUDCAD","AUDCHF","AUDJPY","AUDNZD","AUDSGD","AUDUSD","CADCHF","CADJPY","CHFJPY","CHFSGD",
//"EURAUD","EURCAD","EURCHF","EURGBP","EURJPY","EURNZD","EURSGD","EURUSD","GBPAUD","GBPCAD",
//"GBPCHF","GBPJPY","GBPSGD","GBPUSD","NZDCAD","NZDCHF","NZDJPY","NZDSGD","NZDUSD","SGDJPY",
//"USDCAD","USDCHF","USDHKD","USDJPY","USDSGD","XAUUSD","XAGUSD","AUDDKK","AUDNOK","AUDSEK",
//"CHFNOK","EURDKK","EURHKD","EURNOK","EURSEK","GBPDKK","GBPNOK","GBPSEK","USDDKK","USDRUR"};
//XAUUSD - Gold //XAGUSD - Silver
"EURUSD"};

//double AskSymbol[50];          //===    (50)   
double AskSymbol[1];             //===    (1)   

//int    Period_array[] = {1,5,15,60,240,1440};
//int    Period_array[]={60,240};
int    Period_array[]={60};    // -   15  ( ,   )  5 

//int    prevtime     [50][1];   //=== 50-..  1 
int    prevtime     [1][1];   //=== 1 - ..  1 

//:   KimIV   
//-------    -----------------------------------------+
extern string _P_Expert="----------  ";
extern bool   AllSymbols   = true;     //     
extern int    Magic        = -1;       //  
extern bool   TSProfitOnly = true;     //   
extern int    TStop.Buy    = 300;      //      
extern int    TStop.Sell   = 300;      //      
extern int    TrailingStep = 10;       //    
extern bool   ShowComment  = true;     //  

//-------     ------------------------------+
extern string _P_Performance = "----------  ";
extern bool   UseSound       = True;          //   
extern string SoundSuccess   = "expert.wav";  //  
extern string SoundError     = "timeout.wav"; //  
extern int    NumberOfTry    = 2;             //   

//-------    -------------------------------------+
bool   gbDisabled   = false;           //   
bool   gbNoInit     = false;           //   
color  clModifyBuy  = Aqua;            //    
color  clModifySell = Tomato;          //    

//-------    -----------------------------------------+
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void init()
  {
   gbNoInit=False;
   if (!IsTradeAllowed())
     {
      Message("    \n"+
              "  ");
      gbNoInit=True; return;
     }
   if (!IsLibrariesAllowed())
     {
      Message("    \n"+
              "    ");
      gbNoInit=True; return;
     }
   if (!IsTesting())
     {
      if (IsExpertEnabled()) Message("    ");
      else Message("  \"  \"");
     }
   start();
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetNameOP(int op)
  {
   switch(op)
     {
      case OP_BUY      : return("Buy");
      case OP_SELL     : return("Sell");
      case OP_BUYLIMIT : return("BuyLimit");
      case OP_SELLLIMIT: return("SellLimit");
      case OP_BUYSTOP  : return("BuyStop");
      case OP_SELLSTOP : return("SellStop");
      default          : return("Unknown Operation");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
     color IIFc(bool condition, color ifTrue, color ifFalse)
  {
   if (condition) return(ifTrue); else return(ifFalse);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
     string IIFs(bool condition, string ifTrue, string ifFalse)
  {
   if (condition) return(ifTrue); else return(ifFalse);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Message(string m)
  {
   Comment(m);
   if (StringLen(m)>0) Print(m);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0)
  {
   bool   fm;
   color  cl=IIFc(OrderType()==OP_BUY
               || OrderType()==OP_BUYLIMIT
               || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
   double op, pa, pb, os, ot;
   int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

   if (pp<=0) pp=OrderOpenPrice();
   if (sl<0)sl=OrderStopLoss();
   if (tp<0)tp=OrderTakeProfit();

   pp=NormalizeDouble(pp, dg);
   sl=NormalizeDouble(sl, dg);
   tp=NormalizeDouble(tp, dg);
   op=NormalizeDouble(OrderOpenPrice() , dg);
   os=NormalizeDouble(OrderStopLoss()  , dg);
   ot=NormalizeDouble(OrderTakeProfit(), dg);

   if (pp!=op || sl!=os || tp!=ot)
     {
      for(it=1; it<=NumberOfTry; it++)
        {
         if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
         while(!IsTradeAllowed()) Sleep(5000);
         RefreshRates();
         fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
         if (fm)
           {
            if (UseSound) PlaySound(SoundSuccess); break;
           }
         else
           {
            er=GetLastError();
            if (UseSound) PlaySound(SoundError);
            pa=MarketInfo(OrderSymbol(), MODE_ASK);
            pb=MarketInfo(OrderSymbol(), MODE_BID);
            Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
            Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
                  "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
            Sleep(1000*10);
           }
        }
     }
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SimpleTrailing(string sy="", int op=-1, int mn=-1)
  {
   double po, pp;
   int    i, k=OrdersTotal();

   if (sy=="0") sy=Symbol();
   for(i=0; i<k; i++)
     {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
        {
         if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op))
           {
            po = MarketInfo(OrderSymbol(), MODE_POINT);
            if (mn<0 || OrderMagicNumber()==mn)
              {
               if (OrderType()==OP_BUY)
                 {
                  pp = MarketInfo(OrderSymbol(), MODE_BID);
                  if (!TSProfitOnly || pp-OrderOpenPrice()>TStop.Buy*po)
                    {
                     if (OrderStopLoss()<pp-(TStop.Buy+TrailingStep-1)*po)
                       {
                        ModifyOrder(-1, pp-TStop.Buy*po, -1);
                       }
                    }
                 }
               if (OrderType()==OP_SELL)
                 {
                  pp = MarketInfo(OrderSymbol(), MODE_ASK);
                  if (!TSProfitOnly || OrderOpenPrice()-pp>TStop.Sell*po)
                    {
                     if (OrderStopLoss()>pp+(TStop.Sell+TrailingStep-1)*po || OrderStopLoss()==0)
                       {
                        ModifyOrder(-1, pp+TStop.Sell*po, -1);
                       }
                    }
                 }
              }
           }
        }
     }
  }
//:   KimIV 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

//=====   start()  ======================================================================================
int start() {

   //:   KimIV    
     if (gbDisabled) {
      Message(" !  !"); return; }
     if (gbNoInit)   {
      Message("   !"); return;    }
     if (ShowComment) {
      Comment(IIFs(AllSymbols, "Test "+Versiya+"/ AllSymbols  ", "")
             ,"Magic="+IIFs(Magic<0, "", DoubleToStr(Magic, 0))+"  "
             ,IIFs(TSProfitOnly, "TSProfitOnly  ", "")
             ,"TStop.Buy="+DoubleToStr(TStop.Buy, 0)+"  "
             ,"TStop.Sell="+DoubleToStr(TStop.Sell, 0)+"  "
             ,"TrailingStep="+DoubleToStr(TrailingStep, 0)+"  "
             );
     } else Comment("");

   string sy = IIFs(AllSymbols, "", NULL);
   SimpleTrailing(sy, -1, Magic);
   //:   KimIV      
  
   Startustanovki();           //  
     while(!IsStopped())  {    //   ,       

      int TC1  = TimeCurrent(); //===    
      RefreshRates();          //===     
      Kontrol();               //===                 
      //ProcSP();              //=== ,     (  ),                   
      SymbolPeriod();          //===    /       

      //======================     ========  
      string text  =TimeToStr(TimeCurrent(),TIME_MINUTES);
      int    index=StringFind(text, ":49", 0);   //        ()
      if     (index==2) {bool perezapusk=true;}
      index=StringFind(text, ":50", 0);          //      10      
        if     ((index==2)&&(perezapusk==true)) {
         Print("======================================================");
         Print(" ,    ",TimeToStr(TimeCurrent(),TIME_MINUTES));
         Print("======================================================");   perezapusk=false;  break;
        }
      //======================     ========  

      Sleep(100);                // ! (  )  

      int TC2=TimeCurrent();     //===                   
      int analiz=TC2-TC1;
        if (analiz>TimeCycle)   {
         Print("=================================================================");
         Print("  (",TimeCycle,")   !!!  ",analiz,"         .");
         Print("=================================================================");
         break;
        }
     }
   return(0);                      //   
  }
//=====   start()  ======================================================================================

//=====    ==============================================================================================   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  void Startustanovki()   
  {
   countSymbol =ArraySize(Symbol_array);
   countPeriod =ArraySize(Period_array);
   //===    ===================================     
     for(int i=0; i<countSymbol; i++)      
     {      //===   
      AskSymbol[i]=0;
        for(int j=0; j<countPeriod; j++)   
        {      //===  
         prevtime[i][j]      =0;
        }
     }
   //===     ===================================
  }
//=====    ============================================================================================== 

//=====    ============================================================================================== 
  void Kontrol() {
   if(!IsConnected())       { Print("-----  !------------------------------------------------------------------"); return(0); }
   if(!IsExpertEnabled())   { Print("-----      ! ----------------------------------"); return(0); }
   if(!IsTradeAllowed())    { Print("-----      !    ! -----"); return(0); }
   if(IsTradeContextBusy()) { Print("-----   .  ----------------------------------------------------"); return(0); }
  }
//=====     ============================================================================================== 
    
//=====     ( Vinin)   4066  ==============================================  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
  bool CheckHistory() {
     for(int i=0; i<countSymbol; i++)     {  //===   
        for(int j=0; j<countPeriod; j++)  {  //===  
         double tmp=iClose(Symbol_array[i],Period_array[j],0);
         int    err=GetLastError();
         bool   rez=true;
           if (err==4066) {
            rez=false;
            Print("     ");
            Sleep(1000);                 //     
           }
        }
     }
   return(rez);
  }
//=====     (Vinin)   4066  =================================================== 

//=====    /         ===============================
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SymbolPeriod()     {
   int TT  = 0;
   int TC1 = TimeCurrent();              //===    
   bool NewicS = false; 
     if (CheckHistory()) {               //===     (Vinin)
        for(int i=0; i<countSymbol; i++)     {  //===   
           for(int j=0; j<countPeriod; j++)  {  //===  
            if (isNewBar(i,j))     {          //===          
               Print("-----        i=",i," ",Symbol_array[i],"   j=",j," ",Period_array[j],".            ");
               TT      = 1;               //===   ,      
               //===     i   j ,   
               //===     i-   j-  
               ProcSymbolPeriod_H1(i,j);     //===   101, 102, 103, ...
               //Print("-----             ");
         } 
       }
     }
   } 
   //======================        ()   () ==============       
   int TC2 = TimeCurrent();
   int analiz = TC2 - TC1;
     if ((TT==1)&&(analiz>TimeCycle2)) {  //===        ,         
      Print("               ",analiz,".");
     }
     if (TT==1) {
      //  Print("---------------------    () ----------------");
     }
   //======================            ==============       
}
//=====    /         =============================== 

//=====  true    ,  false  =============================================================  
bool  isNewBar(int i,int j)     {//=== i- ., j- 
   bool res = false;    
   if ( prevtime[i][j] != iTime(Symbol_array[i],Period_array[j],0) )     {
      prevtime[i][j] = iTime(Symbol_array[i],Period_array[j],0);
      res = true;
   } 
  return(res);
}
//=====  true    ,  false  =============================================================   

int ProcSymbolPeriod_H1(int i,int j)  {

   // . 
   string Symb = Symbol_array[i];
   
   // oving Average
   double ;
   double Lot = 0;

   //  
   bool Otkrivaem_Pokupka=false;
   bool Otkrivaem_Prodaga=false;

   //   
   bool EstOrder_Pokupka=false;
   bool EstOrder_Prodaga=false;

   //    -----------------------------------------------------------------------------------  
   //    
   double PriceOpenOrder = 0; //   
   

   //     -----------------------------------------------------------------------------------   

   //   ()  --------------------------------------------------------------------------------------
   double priceClose;       // ,      
   int total = OrdersTotal(); // 
   int ordertype;           //    
   int ticket;              //     
   for(int a = total - 1; a >= 0; a--) {
         if (OrderSelect(i,SELECT_BY_POS)) {
            ordertype = OrderType();
            ticket    = OrderTicket();
            switch(ordertype) {
               case 0:
                  //   
                  //  Bid  
                  if (OrderProfit()<=0) {
                     //    ,   ,    
                     //priceClose = MarketInfo(OrderSymbol(),MODE_BID);
                     //Print("  ",i,"     ",ticket);
                     //OrderClose(ticket,OrderLots(),priceClose,3,Red);
                     break;//    switch    
                    }
                  else {
                     EstOrder_Pokupka = true;
                     break;//    switch    
                    }
               case 1:
                  //  
                  //  Ask  
                  if (OrderProfit()<=0) {
                     //    ,   ,    
                     //priceClose = MarketInfo(OrderSymbol(),MODE_ASK);
                     //Print("  ",i,"     ",ticket);
                     //OrderClose(ticket,OrderLots(),priceClose,3,Red);
                     break;//    switch    
                    }
                  else {
                     EstOrder_Prodaga = true;
                     break;//    switch     
                    }
               default:
                  EstOrder_Pokupka = false;
                  EstOrder_Prodaga = false;
                  //   1  5,   
                  Print("  ",a,"     ",ticket);
                  OrderDelete(ticket);
                  break;//    switch    
              }
           }
        }
   //   ()  --------------------------------------------------------------------------------------

   //     
   int Min_Dist   = MarketInfo(Symb,MODE_STOPLEVEL);                // . 
   double Min_Lot = MarketInfo(Symb,MODE_MINLOT);                   // . . 
   double Free    = AccountFreeMargin();                            //  
   double One_Lot = MarketInfo(Symb,MODE_MARGINREQUIRED);           // .
   
   if (Lots > 0) { Lot = Lots; }                                    //   ,      
   else { Lot = MathFloor(Free*Prots/One_Lot/Min_Lot)*Min_Lot; }    //  

   //     -----------------------------------------------------------------------------------------
   while(((Otkrivaem_Pokupka == true) && (Otkrivaem_Prodaga == false) && (EstOrder_Pokupka == false)))  //   .
     {
      //--------------------------------------------------------------------

      double PriceBuy = PriceOpenOrder;                

      if (NormalizeDouble(PriceBuy,Digits)<             //   .  
         NormalizeDouble(Ask+Min_Dist*Point,Digits))
        {                                               //   BuyStop!

         PriceBuy = Ask + Min_Dist * Point;               //  
         Alert("  : Price = ",PriceBuy);
        }
      //--------------------------------------------------------------------

      if (Est_Dist_SL  == false) { double SL_Buy = PriceOpenOrder;} 
      else { SL_Buy = PriceBuy - Dist_SL * Point; }   //   SL 
             
      Print("Dist_SL: "+Dist_SL+", SL_Buy: "+SL_Buy+", PriceOpenOrder: "+PriceOpenOrder);

      if (Dist_SL < Min_Dist)                     //   .
        {
         SL_Buy = PriceBuy - Min_Dist * Point;             //   SL
         Alert("   SL = ",Min_Dist," pt");
        }
      //--------------------------------------------------------------------
      double TP_Buy = PriceBuy + Dist_TP * Point;          //   
      if (Dist_TP < Min_Dist)                     //   .
        {
         TP_Buy = PriceBuy + Min_Dist * Point;             //   TP
         Alert("   TP = ",Min_Dist," pt");
        }
      //--------------------------------------------------------------------
      for(int tb_Buy=1;tb_Buy<6;tb_Buy++)
        {
         RefreshRates();
         Alert("    .  ..");
         int ticket_Buy = OrderSend(Symb, OP_BUYSTOP, Lot, PriceBuy, 0, SL_Buy, TP_Buy);
         //--------------------------------------------------------------------
         if (ticket_Buy > 0)                             //  :)
           {
            Alert ("  BuyStop ",ticket_Buy);
            break;                                 //   
           }
         //--------------------------------------------------------------------
         int Buy_Error = GetLastError();                 //   :(
         switch(Buy_Error)                             //  
           {
            case 129:Alert(" .   ..");
               RefreshRates();                     //  
               continue;                           //  . 
            case 135:Alert(" .   ..");
               RefreshRates();                     //  
               continue;                           //  . 
            case 146:Alert("  .  ..");
               Sleep(500);                         //  
               RefreshRates();                     //  
               continue;                           //  . 
           }
         switch(Buy_Error)                             //  
           {
            case 2 : Alert(" .");
               break;                              //   switch
            case 5 : Alert("   .");
               break;                              //   switch
            case 64: Alert(" .");
               break;                              //   switch
            case 133:Alert(" ");
               break;                              //   switch
            default: Alert("  ",Buy_Error);//     
           }
        }
      break;                                    //   
     }
   //     -----------------------------------------------------------------------------------------

   //     ----------------------------------------------------------------------------------------
   while(((Otkrivaem_Pokupka == false) && (Otkrivaem_Prodaga == true) && (EstOrder_Prodaga == false)))  //   .
     {
      //--------------------------------------------------------------------

      double PriceSell = PriceOpenOrder;                  

      if (NormalizeDouble(PriceSell,Digits)>              //   .  
         NormalizeDouble(Bid-Min_Dist*Point,Digits))
        {                                                 //   SELLSTOP!
         PriceSell = Bid - Min_Dist * Point;              //  
         Alert("  : Price = ",PriceSell);
        }
      //--------------------------------------------------------------------
      if (Est_Dist_SL  == false) { double SL_Sell =  PriceOpenOrder; }     
      else { SL_Sell = PriceSell + Dist_SL * Point; }               //   SL
                                                                      
      if (Dist_SL < Min_Dist)                                       //   .
        {
         SL_Sell = PriceSell - Min_Dist * Point;                    //   SL
         Alert("   SL = ",Min_Dist," pt");
        }
      //--------------------------------------------------------------------
      double TP_Sell = PriceSell - Dist_TP * Point;                //   
      if (Dist_TP < Min_Dist)                                      //   .
        {
         TP_Sell = PriceSell + Min_Dist * Point;                   //   TP
         Alert("   TP = ",Min_Dist," pt");
        }
      //--------------------------------------------------------------------
      for(int tb_Sell=1;tb_Sell<6;tb_Sell++)
        {
         RefreshRates();
         Alert("    .  ..");
         int ticket_Sell=OrderSend(Symb, OP_SELLSTOP, Lot, PriceSell, 0, SL_Sell, TP_Sell);

         //--------------------------------------------------------------------
         if (ticket_Sell > 0)                             //  :)
           {
            Alert ("  SellStop ",ticket_Sell);
            break;                                 //   
           }
         //--------------------------------------------------------------------
         int Seel_Error = GetLastError();                 //   :(
         switch(Seel_Error)                             //  
           {
            case 129:Alert(" .   ..");
               RefreshRates();                     //  
               continue;                           //  . 
            case 135:Alert(" .   ..");
               RefreshRates();                     //  
               continue;                           //  . 
            case 146:Alert("  .  ..");
               Sleep(500);                         //  
               RefreshRates();                     //  
               continue;                           //  . 
           }
         switch(Seel_Error)                             //  
           {
            case 2 : Alert(" .");
               break;                              //   switch
            case 5 : Alert("   .");
               break;                              //   switch
            case 64: Alert(" .");
               break;                              //   switch
            case 133:Alert(" ");
               break;                              //   switch
            default: Alert("  ",Seel_Error);//     
           }
        }
      break;                                    //   
     }
   //      ----------------------------------------------------------------------------------------      
   return;   //   start()
 }
//+------------------------------------------------------------------+